/*******************************************************************************
 * Copyright (C) 2017 François PETITJEAN
 * Contributors:
 * 	François PETITJEAN
 *  Germain FORESTIER
 * 
 * This file is part of ForestierAIIM2017. 
 * This is a program related to the paper "Automatic matching of surgeries to predict surgeons' 
 * next actions" published in Artificial Intelligence in Medicine" : 
 * http://dx.doi.org/10.1016/j.artmed.2017.03.007
 * 
 * ForestierAIIM2017 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3 of the License.
 * 
 * ForestierAIIM2017 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ForestierAIIM2017.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/
package items;

import java.util.ArrayList;
import java.util.HashMap;

public class Prediction {
	public static void main(String[] args) {
		MonoItemSet a = new MonoItemSet("a");
		MonoItemSet b = new MonoItemSet("b");
		MonoItemSet c = new MonoItemSet("c");
		MonoItemSet d = new MonoItemSet("d");

		MonoItemSet[] seq0 = new MonoItemSet[] { a, a , b };
		MonoItemSet[] seq1 = new MonoItemSet[] { a, b, a, a, a, a };
		MonoItemSet[] seq2 = new MonoItemSet[] { a, a, a, a, b, a, c };
		MonoItemSet[] seq3 = new MonoItemSet[] { a, a, a, d, b, a, a };
		
		Sequence s0 = new Sequence(seq0);
		Sequence s1 = new Sequence(seq1);
		Sequence s2 = new Sequence(seq2);
		Sequence s3 = new Sequence(seq3);
		
		ArrayList<Sequence> sequences = new ArrayList<Sequence>();
		sequences.add(s1);
		sequences.add(s2);
		sequences.add(s3);
		
		HashMap<String,Double> vote = new HashMap<String,Double>();
		
		String rpred = "";
		double max = Double.MIN_VALUE;
		for (int i = 0; i < sequences.size(); i++) {
			Sequence t = sequences.get(i);
			int indexPartial = s0.indexPartial(t);
			System.out.println(s0);
			System.out.println(t);
			System.out.println("prediction: "+indexPartial+" "+t.sequence[indexPartial+1]);
			System.out.println();
			String pred = t.sequence[indexPartial+1].toString();
			if(vote.get(pred) == null) {
				vote.put(pred, 0.0);
			}
			vote.put(pred,vote.get(pred)+1);
			if(vote.get(pred) > max) {
				max = vote.get(pred);
				rpred = pred;
			}
		}
		System.out.println("Final prediction: ["+rpred+"]");
		System.out.println("Agreement rate: "+(max/sequences.size()));
	}
}
